pipeline {
  agent any
  tools {
    maven 'my_maven'
  }
  environment {
    ECRRegistry ='kyontoki/sbimage'
    ECRcredentail ='ecr_cre' 
  }
  parameters {
    string(name: 'test', defaultValue: 'spring')

  }
  stages {
    stage('Maven Build') {
      steps {
        sh 'mvn clean install'
      }
      post {
        failure {
          echo 'maven build failure'
        }
        success {
          echo 'maven build success'
        }
      }
    }
    stage('Dokcer pod deploy') {
      steps {
        podTemplate(yaml: '''
          apiVersion: v1
          kind: Pod
          spec:
            serviceAccountName: jenkins-admin
            volumes:
            - name: docker-socket
              emptyDir: {}
            containers:
            - name: docker
              image: docker
              readinessProbe:
                exec:
                  command: [sh, -c, "ls -S /var/run/docker.sock"]
              command:
              - sleep
              args:
              - 99d
              volumeMounts:
              - name: docker-socket
                mountPath: /var/run
            - name: docker-daemon
              image: docker:dind
              securityContext:
                privileged: true
              volumeMounts:
              - name: docker-socket
                mountPath: /var/run
            - name: kubectl
              image: bitnami/kubectl:1.26.0
              command: 
              - sleep
              args: 
              - 99d
        ''') {
          node(POD_LABEL) {
            container('docker') {
              script {
                stage('Clone Repository') {
                  checkout scm
                }
                stage('Build Docker image') {
                  docker.withRegistry("https://963897741994.dkr.ecr.ap-northeast-2.amazonaws.com", "ecr:ap-northeast-2:aws_cre") {
                     sh "echo ${params.test}"
                    def app = docker.build("963897741994.dkr.ecr.ap-northeast-2.amazonaws.com/spring")  
                    app.push("${env.BUILD_NUMBER}")
                    app.push("latest")
                  }
                } 
              }
            }
          }
        }
      }
    }
  }
}